<template>
    <v-combobox label="Characters to be recognized"
                chips
                clearable
                multiple
                append-icon=""
                v-model="chips"
                :error="isError"
                :error-messages="errorMessages"
                :disabled="disabled"
                @update:search-input="handleSearchInput"
                @change="handleChange">

        <template v-slot:selection="{ item }">
            <v-chip close
                    @click:close="remove(item)">
                <strong>{{ item }}</strong>
            </v-chip>
        </template>

    </v-combobox>
</template>

<script>

    import Vue from 'vue';

    export default {
        name: "AlphabetChips",

        props: {
            value: {
                type: Array,
                required: true
            },
            disabled: {
                type: Boolean,
                required: false,
                default: false
            }
        },

        data () {
            return {
                chips: [],
                isError: false,
                errorMessages: []
            }
        },

        methods: {

            remove (item) {
                this.chips.splice(this.chips.indexOf(item), 1);
                this.chips = [...this.chips]
            },

            handleSearchInput (input) {

                let errors = [];

                if (input && input.length !== 1) {
                    errors.push('Only single characters are supported!');
                }
                if (input && this.chips.indexOf(input) > -1) {
                    errors.push('Duplicate characters are not allowed!');
                }

                this.isError = errors.length > 0;
                this.errorMessages = errors;

                return errors.length > 0;
            },

            // TODO this is very, very wrong! Basically, we are repeating the validation partially here, which is complete BS. But it's a limitation of Vuetify :(
            // TODO after inserting a duplicate character, they get sorted alphabetically. Looks weird
            handleChange(vals) {
                if (vals[vals.length - 1].length != 1) {
                    Vue.delete(this.chips, this.chips.length - 1)
                } else {
                    this.$emit('input', this.chips)
                }

            }
        },


        watch: {
          value(newVal) {
              this.chips = newVal;
          }
        },


        mounted() {
            this.chips = this.value;
        }
    }
</script>

<style scoped>

</style>